### FOR PLOTTING RESULTS OF RUNNING WBM IN JAGS

setwd("SET WORKING DIRECTORY HERE");

### FOR PLOTTING TIME SERIES OF INFERENCES FROM MODEL

### LOAD THE WORKSPACE YOU SAVED THE RESULTS IN

load("GL_L2SWBM_12NF_SM.RData")

### Outputs csv summary table that can be read in a spreadsheet program

write.table(jSum, 'L2SWBM_12NF_SM_stats.csv', sep=',', quote=FALSE);

### NOW some actual plotting

nMonths = posteriorEndMonth;
yearRange = 2005:2014;
compLimits = c(-50, 300)
diversionLimits = c(-25,100)
compLimitsLabs = c(0,150,300)
compLimitsTicks = seq(0,300,150)
diversionLimitsLabs = c(0,50,100)
diversionLimitsTicks = seq(0,100,50)
storeLimits = c(-650,650)

pdf('tsSup_12NF_SM.pdf', width = 10, height = 7.5);
par(mfrow=c(6,1))
par(mar = c(0,0,0,0))
par(oma = c(4,4,4,4))

plot(c(0), c(0), type = "n", axes = FALSE, xlim = c(1,nMonths), ylim = compLimits); 
box()
axis(2, at=compLimitsLabs, cex.lab = 0.7); 
axis(2, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7); 
axis(4, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7); 
mtext(paste("P (mm)"), side = 2, line = 2.5, cex=0.8); 
axis(1, at=seq(1,nMonths,12), labels=FALSE);


for(i in 1:nMonths){
	segments(   
		x0 = i+(1/2), x1 = i+(1/2), lwd = 4, col = 'gray60', lend = 2,
		y0 = jSum[paste('superiorPrecip[',i,']', sep=''),3],
		y1 = jSum[paste('superiorPrecip[',i,']', sep=''),7]
	);
	lines(i+(1/2), jSum[paste('superiorPrecip[',i,']', sep=''),5], col = "black",   lwd = 1, type='p', pch=15, cex=0.75)
	
	lines(c(i, i+1), c(ySuperiorPrecip1[i],ySuperiorPrecip1[i]), col = "red",  lwd=1.5, type='s')
	lines(c(i, i+1), c(ySuperiorPrecip2[i],ySuperiorPrecip2[i]), col = "blue",   lwd=1.5, type='s')
}        

plot(c(0), c(0), type = "n", axes = FALSE, xlim = c(1,nMonths), ylim = compLimits); 
box()
axis(4, at=compLimitsLabs, cex.lab = 0.7); 
axis(4, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7); 
axis(2, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7);  
mtext(paste("E (mm)"), side = 2, line = 2.5, cex=0.8); 
axis(1, at=seq(1,nMonths,12), labels=FALSE);

for(i in 1:nMonths){
	segments(   
		x0 = i+(1/2), x1 = i+(1/2), lwd = 4, col = 'gray60', lend = 2,
		y0 = jSum[paste('superiorEvap[',i,']', sep=''),3],
		y1 = jSum[paste('superiorEvap[',i,']', sep=''),7]
	);
	lines(i+(1/2), jSum[paste('superiorEvap[',i,']', sep=''),5], col = "black",   lwd = 1, type='p', pch=15, cex=0.75)
	
	lines(c(i, i+1), c(ySuperiorEvap1[i],ySuperiorEvap1[i]), col = "red",  lwd=1.5, type='s')
	lines(c(i, i+1), c(ySuperiorEvap2[i],ySuperiorEvap2[i]), col = "blue",   lwd=1.5, type='s')
}        

plot(c(0), c(0), type = "n", axes = FALSE, xlim = c(1,nMonths), ylim = compLimits); 
box()
axis(2, at=compLimitsLabs, cex.lab = 0.7); 
axis(2, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7); 
axis(4, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7); 
mtext(paste("R (mm)"), side = 2, line = 2.5, cex=0.8); 
axis(1, at=seq(1,nMonths,12), labels=FALSE);

for(i in 1:nMonths){
	segments(   
		x0 = i+(1/2), x1 = i+(1/2), lwd = 4, col = 'gray60', lend = 2,
		y0 = jSum[paste('superiorRunoff[',i,']', sep=''),3],
		y1 = jSum[paste('superiorRunoff[',i,']', sep=''),7]
	);
	lines(i+(1/2), jSum[paste('superiorRunoff[',i,']', sep=''),5], col = "black",   lwd = 1, type='p', pch=15, cex=0.75)
	
	
	lines(c(i, i+1), c(ySuperiorRunoff1[i],ySuperiorRunoff1[i]), col = "red",  lwd=1.5, type='s')
	lines(c(i, i+1), c(ySuperiorRunoff2[i],ySuperiorRunoff2[i]), col = "red4",   lwd=1.5, type='s')
}          

plot(c(0), c(0), type = "n", axes = FALSE, xlim = c(1,nMonths), ylim = compLimits); 
box()
axis(4, at=compLimitsLabs, cex.lab = 0.7); 
axis(4, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7); 
axis(2, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7);  
mtext(paste("Q (mm)"), side = 2, line = 2.5, cex=0.8); 
axis(1, at=seq(1,nMonths,12), labels=FALSE);

for(i in 1:nMonths){
	segments(   
		x0 = i+(1/2), x1 = i+(1/2), lwd = 4, col = 'gray60', lend = 2,
		y0 = jSum[paste('superiorOutflow[',i,']', sep=''),3],
		y1 = jSum[paste('superiorOutflow[',i,']', sep=''),7]
	);
	lines(i+(1/2), jSum[paste('superiorOutflow[',i,']', sep=''),5], col = "black",   lwd = 1, type='p', pch=15, cex=0.75)
	
	
	lines(c(i, i+1), c(ySuperiorOutflow1[i],ySuperiorOutflow1[i]), col = "darkgreen",  lwd=1.5, type='s')
	lines(c(i, i+1), c(ySuperiorOutflow2[i],ySuperiorOutflow2[i]), col = "purple",   lwd=1.5, type='s')
}          

plot(ySuperiorDiversion1, type = "n", col = "darkgreen", lwd = 4, axes = FALSE, ylim = diversionLimits, xlim = c(1,nMonths)); 
box()
abline(h=0, col = 8)
axis(2, at=diversionLimitsLabs, cex.lab = 0.7); 
axis(2, at=diversionLimitsTicks, labels=FALSE, cex.lab = 0.7); 
axis(4, at=diversionLimitsTicks, labels=FALSE, cex.lab = 0.7); 
axis(1, at=seq(1,nMonths,12), labels=FALSE);
mtext('D (mm)', side = 2, line = 2.5, cex = 0.8)

for(i in 1:nMonths){
	segments(   
		x0 = i+(1/2), x1 = i+(1/2), lwd = 4, col = 'gray60', lend = 2,
		y0 = jSum[paste('superiorDiversion[',i,']', sep=''),3],
		y1 = jSum[paste('superiorDiversion[',i,']', sep=''),7]
	);
	lines(i+(1/2), jSum[paste('superiorDiversion[',i,']', sep=''),5], col = "black",   lwd = 1, type='p', pch=15, cex=0.75)
	
	lines(c(i, i+1), c(ySuperiorDiversion1[i],ySuperiorDiversion1[i]), col = "darkgreen",  lwd=1.5, type='s')
}

plot(ySuperiorDiversion1, type = "n", col = "darkgreen", lwd = 4, axes = FALSE, ylim = storeLimits, xlim = c(1,nMonths)); 
box()
abline(h=0, col = 8)
axis(4, cex.lab = 0.7); 
axis(2, labels=FALSE, cex.lab = 0.7); 
axis(1, at=seq(1,nMonths,12), labels=FALSE);
axis(1, at=seq(1,nMonths,12)+6, labels=yearRange, tick=FALSE);
mtext(expression(paste(Delta,'H (mm)')), side = 2, line = 2.5, cex = 0.8)

for(i in 1:nMonths){
	segments(   
		x0 = i+(1/2), x1 = i+(1/2), lwd = 4, col = 'gray60', lend = 2,
		y0 = jSum[paste('ySuperiorDStorePP[',i,']', sep=''),3],
		y1 = jSum[paste('ySuperiorDStorePP[',i,']', sep=''),7]
	);
	lines(i+(1/2), jSum[paste('ySuperiorDStorePP[',i,']', sep=''),5], col = "black",   lwd = 1, type='p', pch=15, cex=0.75)
	
	lines(c(i, i+1), c(ySuperiorDStore[i],ySuperiorDStore[i]), col = "goldenrod",  lwd=1.5, type='s')
}

title(main='Superior - Prototype model posterior inferences (mm over lake surface)', outer=TRUE);

dev.off();


pdf('tsMhu_12NF_SM.pdf', width = 10, height = 7.5);
par(mfrow=c(6,1))
par(mar = c(0,0,0,0))
par(oma = c(4,4,4,4))

plot(c(0), c(0), type = "n", axes = FALSE, xlim = c(1,nMonths), ylim = compLimits); 
box()
axis(2, at=compLimitsLabs, cex.lab = 0.7); 
axis(2, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7); 
axis(4, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7); 
mtext(paste("P (mm)"), side = 2, line = 2.5, cex=0.8); 
axis(1, at=seq(1,nMonths,12), labels=FALSE);

for(i in 1:nMonths){
	segments(   
		x0 = i+(1/2), x1 = i+(1/2), lwd = 4, col = 'gray60', lend = 2,
		y0 = jSum[paste('miHuronPrecip[',i,']', sep=''),3],
		y1 = jSum[paste('miHuronPrecip[',i,']', sep=''),7]
	);
	lines(i+(1/2), jSum[paste('miHuronPrecip[',i,']', sep=''),5], col = "black",   lwd = 1, type='p', pch=15, cex=0.75)
	
	lines(c(i, i+1), c(yMiHuronPrecip1[i],yMiHuronPrecip1[i]), col = "red",  lwd=1.5, type='s')
	lines(c(i, i+1), c(yMiHuronPrecip2[i],yMiHuronPrecip2[i]), col = "blue",   lwd=1.5, type='s')
}        

plot(c(0), c(0), type = "n", axes = FALSE, xlim = c(1,nMonths), ylim = compLimits); 
box()
axis(4, at=compLimitsLabs, cex.lab = 0.7); 
axis(4, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7); 
axis(2, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7);  
mtext(paste("E (mm)"), side = 2, line = 2.5, cex=0.8); 
axis(1, at=seq(1,nMonths,12), labels=FALSE);

for(i in 1:nMonths){
	segments(   
		x0 = i+(1/2), x1 = i+(1/2), lwd = 4, col = 'gray60', lend = 2,
		y0 = jSum[paste('miHuronEvap[',i,']', sep=''),3],
		y1 = jSum[paste('miHuronEvap[',i,']', sep=''),7]
	);
	lines(i+(1/2), jSum[paste('miHuronEvap[',i,']', sep=''),5], col = "black",   lwd = 1, type='p', pch=15, cex=0.75)
	
	lines(c(i, i+1), c(yMiHuronEvap1[i],yMiHuronEvap1[i]), col = "red",  lwd=1.5, type='s')
	lines(c(i, i+1), c(yMiHuronEvap2[i],yMiHuronEvap2[i]), col = "blue",   lwd=1.5, type='s')
}        

plot(c(0), c(0), type = "n", axes = FALSE, xlim = c(1,nMonths), ylim = compLimits); 
box()
axis(2, at=compLimitsLabs, cex.lab = 0.7); 
axis(2, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7); 
axis(4, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7); 
mtext(paste("R (mm)"), side = 2, line = 2.5, cex=0.8); 
axis(1, at=seq(1,nMonths,12), labels=FALSE);

for(i in 1:nMonths){
	segments(   
		x0 = i+(1/2), x1 = i+(1/2), lwd = 4, col = 'gray60', lend = 2,
		y0 = jSum[paste('miHuronRunoff[',i,']', sep=''),3],
		y1 = jSum[paste('miHuronRunoff[',i,']', sep=''),7]
	);
	lines(i+(1/2), jSum[paste('miHuronRunoff[',i,']', sep=''),5], col = "black",   lwd = 1, type='p', pch=15, cex=0.75)
	
	lines(c(i, i+1), c(yMiHuronRunoff1[i],yMiHuronRunoff1[i]), col = "red",  lwd=1.5, type='s')
	lines(c(i, i+1), c(yMiHuronRunoff2[i],yMiHuronRunoff2[i]), col = "red4",   lwd=1.5, type='s')
}           

plot(c(0), c(0), type = "n", axes = FALSE, xlim = c(1,nMonths), ylim = compLimits); 
box()
axis(4, at=compLimitsLabs, cex.lab = 0.7); 
axis(4, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7); 
axis(2, at=compLimitsTicks, labels=FALSE, cex.lab = 0.7);  
mtext(paste("Q (mm)"), side = 2, line = 2.5, cex=0.8); 
axis(1, at=seq(1,nMonths,12), labels=FALSE);

for(i in 1:nMonths){
	segments(   
		x0 = i+(1/2), x1 = i+(1/2), lwd = 4, col = 'gray60', lend = 2,
		y0 = jSum[paste('miHuronOutflow[',i,']', sep=''),3],
		y1 = jSum[paste('miHuronOutflow[',i,']', sep=''),7]
	);
	lines(i+(1/2), jSum[paste('miHuronOutflow[',i,']', sep=''),5], col = "black",   lwd = 1, type='p', pch=15, cex=0.75)
	
	lines(c(i, i+1), c(yMiHuronOutflow1[i],yMiHuronOutflow1[i]), col = "darkgreen",  lwd=1.5, type='s')
	lines(c(i, i+1), c(yMiHuronOutflow2[i],yMiHuronOutflow2[i]), col = "purple",   lwd=1.5, type='s')
}         

plot(yMiHuronDiversion1, type = "n", col = "darkgreen", lwd = 4, axes = FALSE, ylim = diversionLimits, xlim = c(1,nMonths)); 
box()
abline(h=0, col = 8)
axis(2, at=diversionLimitsLabs, cex.lab = 0.7); 
axis(2, at=diversionLimitsTicks, labels=FALSE, cex.lab = 0.7); 
axis(4, at=diversionLimitsTicks, labels=FALSE, cex.lab = 0.7); 
axis(1, at=seq(1,nMonths,12), labels=FALSE);
mtext('D (mm)', side = 2, line = 2.5, cex = 0.8)

for(i in 1:nMonths){
	segments(   
		x0 = i+(1/2), x1 = i+(1/2), lwd = 4, col = 'gray60', lend = 2,
		y0 = jSum[paste('miHuronDiversion[',i,']', sep=''),3],
		y1 = jSum[paste('miHuronDiversion[',i,']', sep=''),7]
	);
	lines(i+(1/2), jSum[paste('miHuronDiversion[',i,']', sep=''),5], col = "black",   lwd = 1, type='p', pch=15, cex=0.75)
	
	lines(c(i, i+1), c(yMiHuronDiversion1[i],yMiHuronDiversion1[i]), col = "darkgreen",  lwd=1.5, type='s')
}

plot(yMiHuronDiversion1, type = "n", col = "darkgreen", lwd = 4, axes = FALSE, ylim = storeLimits, xlim = c(1,nMonths)); 
box()
abline(h=0, col = 8)
axis(4, cex.lab = 0.7); 
axis(2, labels=FALSE, cex.lab = 0.7); 
axis(1, at=seq(1,nMonths,12), labels=FALSE);
axis(1, at=seq(1,nMonths,12)+6, labels=yearRange, tick=FALSE);
mtext(expression(paste(Delta,'H (mm)')), side = 2, line = 2.5, cex = 0.8)

for(i in 1:nMonths){
	segments(   
		x0 = i+(1/2), x1 = i+(1/2), lwd = 4, col = 'gray60', lend = 2,
		y0 = jSum[paste('yMiHuronDStorePP[',i,']', sep=''),3],
		y1 = jSum[paste('yMiHuronDStorePP[',i,']', sep=''),7]
	);
	lines(i+(1/2), jSum[paste('yMiHuronDStorePP[',i,']', sep=''),5], col = "black",   lwd = 1, type='p', pch=15, cex=0.75)
	
	lines(c(i, i+1), c(yMiHuronDStore[i],yMiHuronDStore[i]), col = "goldenrod",  lwd=1.5, type='s')
}

title(main='Michigan-Huron - Prototype model posterior inferences (mm over lake surface)', outer=TRUE);

dev.off();

### FOR PLOTTING BIAS INFERENCES FROM MODEL
### Skinnier lines represent biases from NOAA-GLERL GLM-HMD models and coordinated estimates
### Thicker represent biases from ECCC models and International Gauging Stations

## SUPERIOR

pdf('supBias_12NF_SM.pdf', width = 7, height = 3.5, paper = "special", colormodel='gray')
 
layout(matrix(1:36,12,3,TRUE)) #BY ROW
par(oma = c(6,6,6,6))
par(mar = c(0,0,0,0))

thinLineCorrection = 0.45;

for(i in 1:12){
	### Precip
	plot(c(0), c(0), type="n", main="", xaxt="n", yaxt="n", xlim=c(-50,50), ylim=c(-1,2), frame.plot=FALSE);
	rect(
		jSum[paste('ySuperiorPrecip2Bias[',i,']', sep=''),3],
		0,
		jSum[paste('ySuperiorPrecip2Bias[',i,']', sep=''),7],
		1,
		col="#AAAAFF", border="#AAAAFF"
	);
	rect(
		jSum[paste('ySuperiorPrecip1Bias[',i,']', sep=''),3],
		0 + thinLineCorrection,
		jSum[paste('ySuperiorPrecip1Bias[',i,']', sep=''),7],
		1 - thinLineCorrection,
		col="#AA0000", border="#AA0000"
	);
	
	mtext(substr(month.abb[i],1,1), side = 2, line = 2.5, las = 1);
	if(i==1){
		axis(3, at=seq(-50,50,25), labels=FALSE);
	}
	else if(i==12){
		mtext('P', side = 1, line = 3.0);
		axis(1, at=seq(-50,50,25), labels=TRUE);
	}
	abline(v=1, col="gray40", lty=3);
	
	### Evap
	plot(c(0), c(0), type="n", main="", xaxt="n", yaxt="n", xlim=c(-50,50), ylim=c(-1,2), frame.plot=FALSE);
	rect(
		jSum[paste('ySuperiorEvap2Bias[',i,']', sep=''),3],
		0,
		jSum[paste('ySuperiorEvap2Bias[',i,']', sep=''),7],
		1,
		col="#AAAAFF", border="#AAAAFF"
	);
	rect(
		jSum[paste('ySuperiorEvap1Bias[',i,']', sep=''),3],
		0 + thinLineCorrection,
		jSum[paste('ySuperiorEvap1Bias[',i,']', sep=''),7],
		1 - thinLineCorrection,
		col="#AA0000", border="#AA0000"
	);
	
	if(i==1){
		axis(3, at=seq(-50,50,25), labels=TRUE);
	}
	else if(i==12){
		mtext('E', side = 1, line = 3.0);
		axis(1, at=seq(-50,50,25), labels=FALSE);
	}
	abline(v=0, col="gray40", lty=3);
	
	### Runoff
	plot(c(0), c(0), type="n", main="", xaxt="n", yaxt="n", xlim=c(-50,50), ylim=c(-1,2), frame.plot=FALSE);
	rect(
		jSum[paste('ySuperiorRunoff2Bias[',i,']', sep=''),3],
		0,
		jSum[paste('ySuperiorRunoff2Bias[',i,']', sep=''),7],
		1,
		col="#FFFFFF", border="#000000"
	);
	rect(
		jSum[paste('ySuperiorRunoff1Bias[',i,']', sep=''),3],
		0 + thinLineCorrection,
		jSum[paste('ySuperiorRunoff1Bias[',i,']', sep=''),7],
		1 - thinLineCorrection,
		col="#AA0000", border="#AA0000"
	);
	
	if(i==1){
		axis(3, at=seq(-50,50,25), labels=FALSE);
	}
	else if(i==12){
		mtext('R', side = 1, line = 3.0);
		axis(1, at=seq(-50,50,25), labels=TRUE);
	}
	abline(v=1, col="gray40", lty=3);
	
}

box(which="inner");

title(main='Superior Prototype model biases (mm over lake surface)', outer=TRUE);
 
dev.off();  

## MI_HURON

pdf('mhuBias_12NF_SM.pdf', width = 7, height = 3.5, paper = "special", colormodel='gray')
 
layout(matrix(1:36,12,3,TRUE)) #BY ROW
par(oma = c(6,6,6,6))
par(mar = c(0,0,0,0))

thinLineCorrection = 0.45;

for(i in 1:12){
	### Precip
	plot(c(0), c(0), type="n", main="", xaxt="n", yaxt="n", xlim=c(-50,50), ylim=c(-1,2), frame.plot=FALSE);
	rect(
		jSum[paste('yMiHuronPrecip2Bias[',i,']', sep=''),3],
		0,
		jSum[paste('yMiHuronPrecip2Bias[',i,']', sep=''),7],
		1,
		col="#AAAAFF", border="#AAAAFF"
	);
	rect(
		jSum[paste('yMiHuronPrecip1Bias[',i,']', sep=''),3],
		0 + thinLineCorrection,
		jSum[paste('yMiHuronPrecip1Bias[',i,']', sep=''),7],
		1 - thinLineCorrection,
		col="#AA0000", border="#AA0000"
	);
	
	mtext(substr(month.abb[i],1,1), side = 2, line = 2.5, las = 1);
	if(i==1){
		axis(3, at=seq(-50,50,25), labels=FALSE);
	}
	else if(i==12){
		mtext('P', side = 1, line = 3.0);
		axis(1, at=seq(-50,50,25), labels=TRUE);
	}
	abline(v=1, col="gray40", lty=3);
	
	### Evap
	plot(c(0), c(0), type="n", main="", xaxt="n", yaxt="n", xlim=c(-50,50), ylim=c(-1,2), frame.plot=FALSE);
	rect(
		jSum[paste('yMiHuronEvap2Bias[',i,']', sep=''),3],
		0,
		jSum[paste('yMiHuronEvap2Bias[',i,']', sep=''),7],
		1,
		col="#AAAAFF", border="#AAAAFF"
	);
	rect(
		jSum[paste('yMiHuronEvap1Bias[',i,']', sep=''),3],
		0 + thinLineCorrection,
		jSum[paste('yMiHuronEvap1Bias[',i,']', sep=''),7],
		1 - thinLineCorrection,
		col="#AA0000", border="#AA0000"
	);
	
	if(i==1){
		axis(3, at=seq(-50,50,25), labels=TRUE);
	}
	else if(i==12){
		mtext('E', side = 1, line = 3.0);
		axis(1, at=seq(-50,50,25), labels=FALSE);
	}
	abline(v=0, col="gray40", lty=3);
	
	### Runoff
	plot(c(0), c(0), type="n", main="", xaxt="n", yaxt="n", xlim=c(-50,50), ylim=c(-1,2), frame.plot=FALSE);
	rect(
		jSum[paste('yMiHuronRunoff2Bias[',i,']', sep=''),3],
		0,
		jSum[paste('yMiHuronRunoff2Bias[',i,']', sep=''),7],
		1,
		col="#FFFFFF", border="#000000"
	);
	rect(
		jSum[paste('yMiHuronRunoff1Bias[',i,']', sep=''),3],
		0 + thinLineCorrection,
		jSum[paste('yMiHuronRunoff1Bias[',i,']', sep=''),7],
		1 - thinLineCorrection,
		col="#AA0000", border="#AA0000"
	);
	
	if(i==1){
		axis(3, at=seq(-50,50,25), labels=FALSE);
	}
	else if(i==12){
		mtext('R', side = 1, line = 3.0);
		axis(1, at=seq(-50,50,25), labels=TRUE);
	}
	abline(v=1, col="gray40", lty=3);
	
}

box(which="inner");

title(main='Michigan-Huron Prototype model biases (mm over lake surface)', outer=TRUE);
 
dev.off();    
